/**
 * This class is generated by jOOQ
 */
package com.flamesgroup.storage.jooq.tables;


import com.flamesgroup.storage.convert.IccidConverter;
import com.flamesgroup.storage.jooq.Keys;
import com.flamesgroup.storage.jooq.Public;
import com.flamesgroup.storage.jooq.tables.records.SimSerializableDataRecord;
import com.flamesgroup.unit.ICCID;

import java.util.Arrays;
import java.util.List;

import org.jooq.Field;
import org.jooq.Identity;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class SimSerializableData extends TableImpl<SimSerializableDataRecord> {

	private static final long serialVersionUID = 888770223;

	/**
	 * The reference instance of <code>public.sim_serializable_data</code>
	 */
	public static final SimSerializableData SIM_SERIALIZABLE_DATA = new SimSerializableData();

	/**
	 * The class holding records for this type
	 */
	@Override
	public Class<SimSerializableDataRecord> getRecordType() {
		return SimSerializableDataRecord.class;
	}

	/**
	 * The column <code>public.sim_serializable_data.id</code>.
	 */
	public final TableField<SimSerializableDataRecord, Long> ID = createField("id", org.jooq.impl.SQLDataType.BIGINT.nullable(false).defaulted(true), this, "");

	/**
	 * The column <code>public.sim_serializable_data.iccid</code>.
	 */
	public final TableField<SimSerializableDataRecord, ICCID> ICCID = createField("iccid", org.jooq.impl.SQLDataType.CLOB.nullable(false), this, "", new IccidConverter());

	/**
	 * The column <code>public.sim_serializable_data.activity_period_script</code>.
	 */
	public final TableField<SimSerializableDataRecord, byte[]> ACTIVITY_PERIOD_SCRIPT = createField("activity_period_script", org.jooq.impl.SQLDataType.BLOB, this, "");

	/**
	 * The column <code>public.sim_serializable_data.session_script</code>.
	 */
	public final TableField<SimSerializableDataRecord, byte[]> SESSION_SCRIPT = createField("session_script", org.jooq.impl.SQLDataType.BLOB, this, "");

	/**
	 * The column <code>public.sim_serializable_data.gw_selector_script</code>.
	 */
	public final TableField<SimSerializableDataRecord, byte[]> GW_SELECTOR_SCRIPT = createField("gw_selector_script", org.jooq.impl.SQLDataType.BLOB, this, "");

	/**
	 * The column <code>public.sim_serializable_data.business_activity_script</code>.
	 */
	public final TableField<SimSerializableDataRecord, byte[]> BUSINESS_ACTIVITY_SCRIPT = createField("business_activity_script", org.jooq.impl.SQLDataType.BLOB, this, "");

	/**
	 * The column <code>public.sim_serializable_data.factor_script</code>.
	 */
	public final TableField<SimSerializableDataRecord, byte[]> FACTOR_SCRIPT = createField("factor_script", org.jooq.impl.SQLDataType.BLOB, this, "");

	/**
	 * The column <code>public.sim_serializable_data.incoming_call_management_script</code>.
	 */
	public final TableField<SimSerializableDataRecord, byte[]> INCOMING_CALL_MANAGEMENT_SCRIPT = createField("incoming_call_management_script", org.jooq.impl.SQLDataType.BLOB, this, "");

	/**
	 * The column <code>public.sim_serializable_data.vs_factor_script</code>.
	 */
	public final TableField<SimSerializableDataRecord, byte[]> VS_FACTOR_SCRIPT = createField("vs_factor_script", org.jooq.impl.SQLDataType.BLOB, this, "");

	/**
	 * The column <code>public.sim_serializable_data.action_provider_script</code>.
	 */
	public final TableField<SimSerializableDataRecord, byte[]> ACTION_PROVIDER_SCRIPT = createField("action_provider_script", org.jooq.impl.SQLDataType.BLOB, this, "");

	/**
	 * The column <code>public.sim_serializable_data.call_filter_script</code>.
	 */
	public final TableField<SimSerializableDataRecord, byte[]> CALL_FILTER_SCRIPT = createField("call_filter_script", org.jooq.impl.SQLDataType.BLOB, this, "");

	/**
	 * The column <code>public.sim_serializable_data.sms_filter_script</code>.
	 */
	public final TableField<SimSerializableDataRecord, byte[]> SMS_FILTER_SCRIPT = createField("sms_filter_script", org.jooq.impl.SQLDataType.BLOB, this, "");

	/**
	 * The column <code>public.sim_serializable_data.imei_generator_script</code>.
	 */
	public final TableField<SimSerializableDataRecord, byte[]> IMEI_GENERATOR_SCRIPT = createField("imei_generator_script", org.jooq.impl.SQLDataType.BLOB, this, "");

	/**
	 * Create a <code>public.sim_serializable_data</code> table reference
	 */
	public SimSerializableData() {
		this("sim_serializable_data", null);
	}

	/**
	 * Create an aliased <code>public.sim_serializable_data</code> table reference
	 */
	public SimSerializableData(String alias) {
		this(alias, SIM_SERIALIZABLE_DATA);
	}

	private SimSerializableData(String alias, Table<SimSerializableDataRecord> aliased) {
		this(alias, aliased, null);
	}

	private SimSerializableData(String alias, Table<SimSerializableDataRecord> aliased, Field<?>[] parameters) {
		super(alias, Public.PUBLIC, aliased, parameters, "");
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Identity<SimSerializableDataRecord, Long> getIdentity() {
		return Keys.IDENTITY_SIM_SERIALIZABLE_DATA;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public UniqueKey<SimSerializableDataRecord> getPrimaryKey() {
		return Keys.SIM_SERIALIZABLE_DATA_PKEY;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public List<UniqueKey<SimSerializableDataRecord>> getKeys() {
		return Arrays.<UniqueKey<SimSerializableDataRecord>>asList(Keys.SIM_SERIALIZABLE_DATA_PKEY, Keys.SIM_SERIALIZABLE_DATA_KEY);
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public SimSerializableData as(String alias) {
		return new SimSerializableData(alias, this);
	}

	/**
	 * Rename this table
	 */
	public SimSerializableData rename(String name) {
		return new SimSerializableData(name, null);
	}
}
